import React, { PureComponent } from "react";
export default class BottomSheet extends PureComponent<IBottomSheetProps, IBottomSheetState> {
    constructor(props: IBottomSheetProps);
    componentDidMount(): void;
    componentWillUpdate(nextProps: Readonly<IBottomSheetProps>, nextState: Readonly<{}>, nextContext: any): void;
    componentDidUpdate(prevProps: Readonly<IBottomSheetProps>): void;
    handleTouchMove(e: Event): void;
    onEnter(): void;
    onExit(): void;
    lockWebKitBodyScrolling(): void;
    unlockWebKitBodyScrolling(): void;
    componentWillUnmount(): void;
    render(): React.JSX.Element | null;
    private bottomSheetBodyClick;
}
interface IBottomSheetProps {
    show: boolean;
    children?: React.ReactNode;
    onChange?: (status: boolean) => void;
    className?: string;
    onClose: () => void;
    transitionTimeout?: {
        enter: number;
        exit: number;
    };
}
interface IBottomSheetState {
    scrollPosition: number;
}
export {};
