"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importStar(require("react"));
var react_transition_group_1 = require("react-transition-group");
var BottomSheet = /** @class */ (function (_super) {
    __extends(BottomSheet, _super);
    function BottomSheet(props) {
        var _this = _super.call(this, props) || this;
        _this.bottomSheetBodyClick = function (event) {
            event.stopPropagation();
        };
        _this.handleTouchMove = _this.handleTouchMove.bind(_this);
        _this.onEnter = _this.onEnter.bind(_this);
        _this.onExit = _this.onExit.bind(_this);
        _this.state = { scrollPosition: 0 };
        return _this;
    }
    BottomSheet.prototype.componentDidMount = function () {
        if (this.props.show && typeof window !== "undefined") {
            this.lockWebKitBodyScrolling();
        }
    };
    BottomSheet.prototype.componentWillUpdate = function (nextProps, nextState, nextContext) {
        if (nextProps.show !== this.props.show &&
            nextProps.show &&
            typeof window !== "undefined") {
            this.lockWebKitBodyScrolling();
        }
        else if (nextProps.show !== this.props.show &&
            !nextProps.show &&
            typeof window !== "undefined") {
            this.unlockWebKitBodyScrolling();
        }
    };
    BottomSheet.prototype.componentDidUpdate = function (prevProps) {
        if (prevProps.show !== this.props.show) {
            if (prevProps.onChange) {
                prevProps.onChange(this.props.show);
            }
        }
    };
    BottomSheet.prototype.handleTouchMove = function (e) {
        e.stopImmediatePropagation();
        var scrollElement = document.getElementsByClassName("q-bottom-sheet-main")[0];
        if (!e.composedPath().includes(scrollElement)) {
            e.preventDefault();
        }
    };
    BottomSheet.prototype.onEnter = function () {
        document.addEventListener("touchmove", this.handleTouchMove, {
            passive: false,
        });
    };
    BottomSheet.prototype.onExit = function () {
        document.removeEventListener("touchmove", this.handleTouchMove);
    };
    BottomSheet.prototype.lockWebKitBodyScrolling = function () {
        var scrollPosition = window.pageYOffset;
        this.setState({ scrollPosition: scrollPosition });
        window.document.body.style.overflow = "hidden";
        window.document.body.style.position = "fixed";
        window.document.body.style.top = "-".concat(scrollPosition, "px");
        window.document.body.style.width = "100%";
    };
    BottomSheet.prototype.unlockWebKitBodyScrolling = function () {
        window.document.body.style.removeProperty("overflow");
        window.document.body.style.removeProperty("position");
        window.document.body.style.removeProperty("top");
        window.document.body.style.removeProperty("width");
        window.scrollTo(0, this.state.scrollPosition);
    };
    BottomSheet.prototype.componentWillUnmount = function () {
        document.removeEventListener("touchmove", this.handleTouchMove);
        this.unlockWebKitBodyScrolling();
    };
    BottomSheet.prototype.render = function () {
        if (typeof window === "undefined") {
            return null;
        }
        var _a = this.props, show = _a.show, children = _a.children, onClose = _a.onClose, className = _a.className, transitionTimeout = _a.transitionTimeout;
        var bottomSheetClasses = (0, classnames_1.default)("q-bottom-sheet-main", className);
        var overlayClick = function () {
            onClose();
        };
        return (react_1.default.createElement(react_transition_group_1.CSSTransition, { in: show, onEnter: this.onEnter, onExit: this.onExit, unmountOnExit: true, timeout: __assign({ enter: 0, exit: 200 }, transitionTimeout), classNames: "q-slideInDown q-bottom-sheet" },
            react_1.default.createElement("div", { className: "q-bottom-sheet-overlay", onClick: overlayClick },
                react_1.default.createElement("div", { className: bottomSheetClasses, onClick: this.bottomSheetBodyClick }, children))));
    };
    return BottomSheet;
}(react_1.PureComponent));
exports.default = BottomSheet;
//# sourceMappingURL=bottom-sheet.js.map