"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var countdown_1 = require("../../enums/countdown");
var Countdown = /** @class */ (function (_super) {
    __extends(Countdown, _super);
    function Countdown(props) {
        var _this = _super.call(this, props) || this;
        _this.timeoutHandler = null;
        _this.state = {
            intervalHandler: null,
            remainingDays: "",
            remainingHours: "",
            remainingMinutes: "",
            remainingSeconds: "",
            visible: false,
        };
        return _this;
    }
    Countdown.prototype.componentDidMount = function () {
        var _this = this;
        if (Date.now() + this.props.threshold >= this.props.endDate) {
            this.updateCountdown();
            this.setState({
                intervalHandler: setInterval(this.updateCountdown.bind(this), countdown_1.INTERVAL_HANDLER_TIME),
            });
        }
        else {
            var timeToStartShowingCountdown = Math.min(Math.max(this.props.endDate - (Date.now() + this.props.threshold), 0), Number.MAX_SAFE_INTEGER);
            this.timeoutHandler = setTimeout(function () {
                _this.setState({
                    intervalHandler: setInterval(_this.updateCountdown.bind(_this), countdown_1.INTERVAL_HANDLER_TIME),
                });
            }, timeToStartShowingCountdown);
        }
    };
    Countdown.prototype.componentWillUnmount = function () {
        if (this.timeoutHandler) {
            clearTimeout(this.timeoutHandler);
        }
        if (this.state.intervalHandler) {
            clearInterval(this.state.intervalHandler);
        }
    };
    Countdown.prototype.render = function () {
        var _this = this;
        var _a = this.props.day, day = _a === void 0 ? countdown_1.DATE_STRINGS.DAY : _a;
        var countdown = function () { return (react_1.default.createElement("div", null,
            _this.state.remainingDays > 0 ?
                react_1.default.createElement("span", null,
                    react_1.default.createElement("span", null, _this.state.remainingDays),
                    react_1.default.createElement("span", null,
                        "\u00A0",
                        day,
                        "\u00A0"),
                    react_1.default.createElement("span", null,
                        _this.padNumber(_this.state.remainingHours),
                        react_1.default.createElement("span", null, ":")),
                    react_1.default.createElement("span", null,
                        _this.padNumber(_this.state.remainingMinutes),
                        react_1.default.createElement("span", null, ":"))) : _this.renderHoursAndMinutes(),
            react_1.default.createElement("span", null, _this.padNumber(_this.state.remainingSeconds)))); };
        return this.state.visible ? countdown() : null;
    };
    Countdown.prototype.padNumber = function (n) {
        return n > 9 ? "".concat(n) : "0".concat(n);
    };
    Countdown.prototype.updateCountdown = function () {
        var _a = this.props.gmt, gmt = _a === void 0 ? 0 : _a;
        var remainingTime = this.props.endDate - Date.now();
        if (remainingTime <= 0) {
            return this.setState({
                remainingDays: 0,
                remainingHours: 0,
                remainingMinutes: 0,
                remainingSeconds: 0,
                visible: false,
            });
        }
        var remainingSeconds = Math.floor((remainingTime / 1000) % 60);
        var remainingMinutes = Math.floor((remainingTime / (1000 * 60)) % 60);
        var remainingHours = Math.floor((remainingTime / (1000 * 60 * 60)) % 24) + gmt;
        var remainingDays = Math.floor(remainingTime / (((1000 * 60 * 60) + gmt) * 24));
        return this.setState({
            remainingDays: remainingDays,
            remainingHours: remainingHours,
            remainingMinutes: remainingMinutes,
            remainingSeconds: remainingSeconds,
            visible: true,
        });
    };
    Countdown.prototype.renderHoursAndMinutes = function () {
        var _a = this.props, _b = _a.hour, hour = _b === void 0 ? countdown_1.DATE_STRINGS.HOUR : _b, _c = _a.minute, minute = _c === void 0 ? countdown_1.DATE_STRINGS.MINUTE : _c;
        if (this.state.remainingHours > 0) {
            return (react_1.default.createElement("span", null,
                react_1.default.createElement("span", null,
                    this.state.remainingHours,
                    react_1.default.createElement("span", null,
                        "\u00A0",
                        hour,
                        "\u00A0")),
                react_1.default.createElement("span", null, this.padNumber(this.state.remainingMinutes)),
                react_1.default.createElement("span", null, ":")));
        }
        return react_1.default.createElement("span", null,
            this.padNumber(this.state.remainingMinutes),
            " ",
            react_1.default.createElement("span", null,
                "\u00A0",
                minute,
                "\u00A0"));
    };
    return Countdown;
}(react_1.PureComponent));
exports.default = Countdown;
//# sourceMappingURL=countdown.js.map