import React, { PropsWithChildren, PureComponent } from "react";
export default class Popup extends PureComponent<PropsWithChildren<IPopupProps>, IPopupState> {
    constructor(props: IPopupProps);
    componentDidMount(): void;
    componentWillUpdate(nextProps: Readonly<IPopupProps>, nextState: Readonly<{}>, nextContext: any): void;
    componentDidUpdate(prevProps: Readonly<IPopupProps>): void;
    componentWillUnmount(): void;
    handleTouchMove(e: Event): void;
    onEnter(): void;
    onExit(): void;
    lockWebKitBodyScrolling(): void;
    unlockWebKitBodyScrolling(): void;
    render(): React.ReactPortal | null;
    private popupBodyClick;
}
interface IPopupProps {
    show: boolean;
    onChange: (status: boolean) => void;
    iconLeft?: boolean;
    noIcon?: boolean;
    closeOnOverlayClick?: boolean;
    className?: string;
    contentClassName?: string;
    title?: React.ReactElement | string;
    withTitleBorder?: boolean;
    children?: React.ReactNode;
}
interface IPopupState {
    scrollPosition: number;
}
export {};
