"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importStar(require("react"));
var react_dom_1 = __importDefault(require("react-dom"));
var react_transition_group_1 = require("react-transition-group");
var icon_1 = __importDefault(require("../icon"));
var Popup = /** @class */ (function (_super) {
    __extends(Popup, _super);
    function Popup(props) {
        var _this = _super.call(this, props) || this;
        _this.popupBodyClick = function (event) {
            event.stopPropagation();
        };
        _this.handleTouchMove = _this.handleTouchMove.bind(_this);
        _this.onEnter = _this.onEnter.bind(_this);
        _this.onExit = _this.onExit.bind(_this);
        _this.state = { scrollPosition: 0 };
        return _this;
    }
    Popup.prototype.componentDidMount = function () {
        if (this.props.show && typeof window !== "undefined") {
            this.lockWebKitBodyScrolling();
        }
    };
    Popup.prototype.componentWillUpdate = function (nextProps, nextState, nextContext) {
        if (nextProps.show !== this.props.show &&
            nextProps.show &&
            typeof window !== "undefined") {
            this.lockWebKitBodyScrolling();
        }
        else if (nextProps.show !== this.props.show &&
            !nextProps.show &&
            typeof window !== "undefined") {
            this.unlockWebKitBodyScrolling();
        }
    };
    Popup.prototype.componentDidUpdate = function (prevProps) {
        if (prevProps.show !== this.props.show) {
            if (prevProps.onChange) {
                prevProps.onChange(this.props.show);
            }
        }
    };
    Popup.prototype.componentWillUnmount = function () {
        window.document.removeEventListener("touchmove", this.handleTouchMove);
        this.unlockWebKitBodyScrolling();
    };
    Popup.prototype.handleTouchMove = function (e) {
        e.stopImmediatePropagation();
        var scrollElement = document.getElementsByClassName("q-popup-content")[0];
        if (!e.composedPath().includes(scrollElement)) {
            e.preventDefault();
        }
    };
    Popup.prototype.onEnter = function () {
        window.document.addEventListener("touchmove", this.handleTouchMove, {
            passive: false,
        });
    };
    Popup.prototype.onExit = function () {
        window.document.removeEventListener("touchmove", this.handleTouchMove);
    };
    Popup.prototype.lockWebKitBodyScrolling = function () {
        var scrollPosition = window.pageYOffset;
        this.setState({ scrollPosition: scrollPosition });
        window.document.body.style.overflow = "hidden";
        window.document.body.style.position = "fixed";
        window.document.body.style.top = "-".concat(scrollPosition, "px");
        window.document.body.style.width = "100%";
    };
    Popup.prototype.unlockWebKitBodyScrolling = function () {
        window.document.body.style.removeProperty("overflow");
        window.document.body.style.removeProperty("position");
        window.document.body.style.removeProperty("top");
        window.document.body.style.removeProperty("width");
        if (this.state.scrollPosition) {
            window.scrollTo(0, this.state.scrollPosition);
        }
    };
    Popup.prototype.render = function () {
        if (typeof window === "undefined") {
            return null;
        }
        var _a = this.props, show = _a.show, children = _a.children, iconLeft = _a.iconLeft, _b = _a.noIcon, noIcon = _b === void 0 ? false : _b, _c = _a.closeOnOverlayClick, closeOnOverlayClick = _c === void 0 ? true : _c, onChange = _a.onChange, className = _a.className, contentClassName = _a.contentClassName, title = _a.title, withTitleBorder = _a.withTitleBorder;
        var popupClasses = (0, classnames_1.default)("q-popup-overlay", className);
        var popupIconClasses = (0, classnames_1.default)(iconLeft && "q-popup-icon-left", "icon-close", "q-popup-icon-position");
        var popupContentClasses = (0, classnames_1.default)(contentClassName, "q-popup-content");
        var popupTitleClasses = (0, classnames_1.default)({
            "q-popup-header": true,
            "with-border": withTitleBorder === true,
        });
        var overlayClick = function (e) {
            e.stopPropagation();
            if (closeOnOverlayClick) {
                onChange(false);
            }
        };
        var handleIconClick = function () {
            onChange(false);
        };
        return react_dom_1.default.createPortal(react_1.default.createElement(react_transition_group_1.CSSTransition, { in: show, onEnter: this.onEnter, onExit: this.onExit, unmountOnExit: true, timeout: 150, classNames: "q-zoomIn q-popup" },
            react_1.default.createElement("div", { className: popupClasses, onClick: overlayClick },
                react_1.default.createElement("div", { className: "q-popup-main", onClick: this.popupBodyClick },
                    (!noIcon || title) && (react_1.default.createElement("div", { className: popupTitleClasses },
                        react_1.default.createElement("div", { className: "q-popup-header-text" }, title),
                        !noIcon && (react_1.default.createElement(icon_1.default, { className: popupIconClasses, onClick: handleIconClick, name: "close", sizePixel: 10 })))),
                    react_1.default.createElement("div", { className: popupContentClasses }, children)))), window.document.body);
    };
    return Popup;
}(react_1.PureComponent));
exports.default = Popup;
//# sourceMappingURL=popup.js.map