"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importStar(require("react"));
var class_names_default_1 = __importDefault(require("../../utils/class-names-default"));
var icon_1 = __importDefault(require("../icon"));
var Rating = /** @class */ (function (_super) {
    __extends(Rating, _super);
    function Rating() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.defaultSizeMapping = {
            large: 18,
            medium: 14,
            small: 10,
        };
        _this.defaultMargin = 3;
        _this.defaultStars = 5;
        return _this;
    }
    Rating.prototype.calculateWidth = function (score, size, margin, stars) {
        var plus = (Math.ceil(score) - 1) * margin;
        return (score * this.defaultSizeMapping[size] + plus) * 100 /
            (stars * this.defaultSizeMapping[size] + margin * (stars - 1));
    };
    Rating.prototype.render = function () {
        var _a = this.props, _b = _a.value, value = _b === void 0 ? 0 : _b, _c = _a.icon, icon = _c === void 0 ? "star" : _c, _d = _a.size, size = _d === void 0 ? "medium" : _d, _e = _a.color, color = _e === void 0 ? "yellow" : _e, disabled = _a.disabled, children = _a.children, className = _a.className, _f = _a.margin, margin = _f === void 0 ? this.defaultMargin : _f, _g = _a.stars, stars = _g === void 0 ? this.defaultStars : _g, props = __rest(_a, ["value", "icon", "size", "color", "disabled", "children", "className", "margin", "stars"]);
        var ratingClasses = (0, classnames_1.default)((0, class_names_default_1.default)({ disabled: disabled }), "q-rating", size && "q-rating-".concat(size), className);
        return (react_1.default.createElement("div", __assign({ className: ratingClasses }, props),
            react_1.default.createElement("div", { className: "q-rating-empty" }, Array.from({ length: stars }, function (_, i) {
                return react_1.default.createElement(icon_1.default, { key: i, style: { marginRight: "".concat(i + 1 === stars ? 0 : margin, "px") }, name: icon });
            })),
            react_1.default.createElement("div", { style: { width: "".concat(this.calculateWidth(value, size, margin, stars), "%") }, className: "q-rating-full" }, Array.from({ length: stars }, function (_, i) {
                return react_1.default.createElement(icon_1.default, { key: i, style: { marginRight: "".concat(i + 1 === stars ? 0 : margin, "px") }, name: icon, color: color });
            }))));
    };
    return Rating;
}(react_1.PureComponent));
exports.default = Rating;
//# sourceMappingURL=rating.js.map